/* ************************************************************************** *
   This file is part of ceDonkey.

   ceDonkey is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   ceDonkey is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with ceDonkey; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * ************************************************************************** */
#ifndef packet_gen
#define packet_gen 1

#include "structs.h"


void ed2k_message_gen_init();


// tcp request


// udp request

// warning: these functions require SERVER addresses, which is 
// with the address set to TCP CONNECTION PORT!

gint 
ed2k_send_udp_ping(GInetAddr *);

gint
ed2k_send_udp_req_srvlist(GInetAddr *);

gint
ed2k_send_udp_srv_announce(GInetAddr *);

gint
ed2k_send_udp_push_fail(GInetAddr *);

// tcp response

gint 
ed2k_send_0x40(struct UserInfo *);

gint 
ed2k_send_server_greeting(struct UserInfo *);

gint 
ed2k_send_string(struct UserInfo*, char*, int);

gint
ed2k_send_server_desc(struct UserInfo *);

gint 
ed2k_return_search_results(struct UserInfo*, struct SearchResults*, int);

gint 
ed2k_send_download_sources(struct UserInfo*, struct FileInfo*, 
			   struct SearchResults *, int);

gint
ed2k_send_push_command(struct UserInfo *, guint, gushort);

gint
ed2k_send_push_fail(struct UserInfo *);

gint
ed2k_send_serverlist(struct UserInfo *);

gint
ed2k_send_server_status(struct UserInfo *);


// udp response


gint 
ed2k_send_udp_pong(struct message_handle_struct *);

gint
ed2k_send_push_command_udp(struct UserInfo *, guint, gushort);

gint
ed2k_send_udp_download_sources(GInetAddr *, char *,
			       struct SearchResults *, int);

gint
ed2k_send_udp_serverlist(GInetAddr *);


#endif
