/* ************************************************************************** *
   This file is part of ceDonkey.

   ceDonkey is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   ceDonkey is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with ceDonkey; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * ************************************************************************** */
#include <glib-2.0/glib.h>

#include "structs.h"
#include "logging.h"
#include "settings.h"
#include "littlehelpers.h"



extern struct central_struct *rome;



gint 
logging_init()
{

   return 1;
}

gint
log_unknown_event()
{
   printf("\t ERROR - what is this??? LOGGING FAILED\n");
   return 0;
}



gint
count_tcp_traffic(struct UserInfo *user, gint type, gint size)
{

   if (type < 0x20) 
      {
	 // this was incoming
	 ((rome->stat_tcp).got_messages)++;
	 ((rome->stat_tcp).got_bytes) += size + 5;
	 ((user->stat_tcp).got_messages)++;
	 ((user->stat_tcp).got_bytes) += size + 5;
      }
   else
      {
	 // this was outgoing
	 ((rome->stat_tcp).sent_messages)++;
	 ((rome->stat_tcp).sent_bytes) += size + 5;
	 ((user->stat_tcp).sent_messages)++;
	 ((user->stat_tcp).sent_bytes) += size + 5;
      }


   switch (type)
      {
	 // incoming
	 
      case T01:
	 ((rome->stat_tcp).got_0x01)++;
	 ((rome->stat_tcp).got_0x01_bytes) += size + 5;
	 ((user->stat_tcp).got_0x01)++;
	 ((user->stat_tcp).got_0x01_bytes) += size + 5;
	 break;
      case T14:
	 ((rome->stat_tcp).got_0x14)++;
	 ((rome->stat_tcp).got_0x14_bytes) += size + 5;
	 ((user->stat_tcp).got_0x14)++;
	 ((user->stat_tcp).got_0x14_bytes) += size + 5;
	 break;
      case T15:
	 ((rome->stat_tcp).got_0x15)++;
	 ((rome->stat_tcp).got_0x15_bytes) += size + 5;
	 ((user->stat_tcp).got_0x15)++;
	 ((user->stat_tcp).got_0x15_bytes) += size + 5;
	 break;
      case T16:
	 ((rome->stat_tcp).got_0x16)++;
	 ((rome->stat_tcp).got_0x16_bytes) += size + 5;
	 ((user->stat_tcp).got_0x16)++;
	 ((user->stat_tcp).got_0x16_bytes) += size + 5;
	 break;
      case T19:
	 ((rome->stat_tcp).got_0x19)++;
	 ((rome->stat_tcp).got_0x19_bytes) += size + 5;
	 ((user->stat_tcp).got_0x19)++;
	 ((user->stat_tcp).got_0x19_bytes) += size + 5;
	 break;
      case T1c:
	 ((rome->stat_tcp).got_0x1c)++;
	 ((rome->stat_tcp).got_0x1c_bytes) += size + 5;
	 ((user->stat_tcp).got_0x1c)++;
	 ((user->stat_tcp).got_0x1c_bytes) += size + 5;
	 break;

	 // outgoing

      case T32:
	 ((rome->stat_tcp).sent_0x32)++;
	 ((rome->stat_tcp).sent_0x32_bytes) += size + 5;
	 ((user->stat_tcp).sent_0x32)++;
	 ((user->stat_tcp).sent_0x32_bytes) += size + 5;
	 break;
      case T33:
	 ((rome->stat_tcp).sent_0x33)++;
	 ((rome->stat_tcp).sent_0x33_bytes) += size + 5;
	 ((user->stat_tcp).sent_0x33)++;
	 ((user->stat_tcp).sent_0x33_bytes) += size + 5;
	 break;
      case T34:
	 ((rome->stat_tcp).sent_0x34)++;
	 ((rome->stat_tcp).sent_0x34_bytes) += size + 5;
	 ((user->stat_tcp).sent_0x34)++;
	 ((user->stat_tcp).sent_0x34_bytes) += size + 5;
	 break;
      case T35:
	 ((rome->stat_tcp).sent_0x35)++;
	 ((rome->stat_tcp).sent_0x35_bytes) += size + 5;
	 ((user->stat_tcp).sent_0x35)++;
	 ((user->stat_tcp).sent_0x35_bytes) += size + 5;
	 break;
      case T38:
	 ((rome->stat_tcp).sent_0x38)++;
	 ((rome->stat_tcp).sent_0x38_bytes) += size + 5;
	 ((user->stat_tcp).sent_0x38)++;
	 ((user->stat_tcp).sent_0x38_bytes) += size + 5;
	 break;
      case T40:
	 ((rome->stat_tcp).sent_0x40)++;
	 ((rome->stat_tcp).sent_0x40_bytes) += size + 5;
	 ((user->stat_tcp).sent_0x40)++;
	 ((user->stat_tcp).sent_0x40_bytes) += size + 5;
	 break;
      case T41:
	 ((rome->stat_tcp).sent_0x41)++;
	 ((rome->stat_tcp).sent_0x41_bytes) += size + 5;
	 ((user->stat_tcp).sent_0x41)++;
	 ((user->stat_tcp).sent_0x41_bytes) += size + 5;
	 break;
      case T42:
	 ((rome->stat_tcp).sent_0x42)++;
	 ((rome->stat_tcp).sent_0x42_bytes) += size + 5;
	 ((user->stat_tcp).sent_0x42)++;
	 ((user->stat_tcp).sent_0x42_bytes) += size + 5;
	 break;
	 
	 // unknown

      case T00:
	 ((rome->stat_tcp).got_unknown)++;
	 ((rome->stat_tcp).got_unknown_bytes) += size;
	 break;

	 // default

      default:
	 log_unknown_event();
      }


   return 1;
}



gint
count_udp_traffic(gint type, gint size, gint direction)
{
   if (direction == UDP_IN)
      {
	 ((rome->stat_udp).got_packets)++;
	 ((rome->stat_udp).got_bytes) += size;
      }
   else
      {
	 ((rome->stat_udp).sent_packets)++;
	 ((rome->stat_udp).sent_bytes) += size;
      }


   switch (type)
      {
	 // incoming
	 
      case U96:
	 if (direction == UDP_IN)
	    {
	       ((rome->stat_udp).got_0x96)++;
	       ((rome->stat_udp).got_0x96_bytes) += size;
	    }
	 else if (direction == UDP_OUT)
	    {
	       ((rome->stat_udp).sent_0x96)++;
	       ((rome->stat_udp).sent_0x96_bytes) += size;
	    }
	 else
	    g_assert_not_reached();
	 break;
      case U97:
	 if (direction == UDP_IN)
	    {
	       ((rome->stat_udp).got_0x97)++;
	       ((rome->stat_udp).got_0x97_bytes) += size;
	    }
	 else if (direction == UDP_OUT)
 	    {
	       ((rome->stat_udp).sent_0x97)++;
	       ((rome->stat_udp).sent_0x97_bytes) += size;
	    }
	 else
	    g_assert_not_reached();
	 break;
      case U98:
	 if (direction == UDP_IN)
	    {
	       ((rome->stat_udp).got_0x98)++;
	       ((rome->stat_udp).got_0x98_bytes) += size;
	    }
	 else if (direction == UDP_OUT)
	    {
	       g_assert_not_reached();
	    }
	 else
	    g_assert_not_reached();
	 break;
      case U99:
	 if (direction == UDP_IN)
	    {
	       g_assert_not_reached();
	    }
	 else if (direction == UDP_OUT)
	    {
	       ((rome->stat_udp).sent_0x99)++;
	       ((rome->stat_udp).sent_0x99_bytes) += size;
	    }
	 else
	    g_assert_not_reached();
	 break;
      case U9a:
	 if (direction == UDP_IN)
	    {
	       ((rome->stat_udp).got_0x9a)++;
	       ((rome->stat_udp).got_0x9a_bytes) += size;
	    }
	 else if (direction == UDP_OUT)
	    {
	       g_assert_not_reached();
	    }
	 else
	    g_assert_not_reached();
	 break;
      case U9b:
	 if (direction == UDP_IN)
	    {
	       g_assert_not_reached();
	    }
	 else if (direction == UDP_OUT)
	    {
	       ((rome->stat_udp).sent_0x9b)++;
	       ((rome->stat_udp).sent_0x9b_bytes) += size;
	    }
	 else
	    g_assert_not_reached();
	 break;
      case U9c:
	 if (direction == UDP_IN)
	    {
	       ((rome->stat_udp).got_0x9c)++;
	       ((rome->stat_udp).got_0x9c_bytes) += size;
	    }
	 else if (direction == UDP_OUT)
	    {
	       g_assert_not_reached();
	    }
	 else
	    g_assert_not_reached();
	 break;
      case U9e:
	 if (direction == UDP_IN)
	    {
	       g_assert_not_reached();
	    }
	 else if (direction == UDP_OUT)
	    {
	       ((rome->stat_udp).sent_0x9e)++;
	       ((rome->stat_udp).sent_0x9e_bytes) += size;
	    }
	 else
	    g_assert_not_reached();
	 break;
      case Ua0:
	 if (direction == UDP_IN)
	    {
	       ((rome->stat_udp).got_0xa0)++;
	       ((rome->stat_udp).got_0xa0_bytes) += size;
	    }
	 else if (direction == UDP_OUT)
	    {
	       ((rome->stat_udp).sent_0xa0)++;
	       ((rome->stat_udp).sent_0xa0_bytes) += size;
	    }
	 else
	    g_assert_not_reached();
	 break;
      case Ua1:
	 if (direction == UDP_IN)
	    {
	       ((rome->stat_udp).got_0xa1)++;
	       ((rome->stat_udp).got_0xa1_bytes) += size;
	    }
	 else if (direction == UDP_OUT)
	    {
	       ((rome->stat_udp).sent_0xa1)++;
	       ((rome->stat_udp).sent_0xa1_bytes) += size;
	    }
	 else
	    g_assert_not_reached();
	 break;
      case Ua2:
	 if (direction == UDP_IN)
	    {
	       ((rome->stat_udp).got_0xa2)++;
	       ((rome->stat_udp).got_0xa2_bytes) += size;
	    }
	 else if (direction == UDP_OUT)
	    {
	       ((rome->stat_udp).sent_0xa2)++;
	       ((rome->stat_udp).sent_0xa2_bytes) += size;
	    }
	 else
	    g_assert_not_reached();
	 break;
      case Ua3:
	 if (direction == UDP_IN)
	    {
	       ((rome->stat_udp).got_0xa3)++;
	       ((rome->stat_udp).got_0xa3_bytes) += size;
	    }
	 else if (direction == UDP_OUT)
	    {
	       ((rome->stat_udp).sent_0xa3)++;
	       ((rome->stat_udp).sent_0xa3_bytes) += size;
	    }
	 else
	    g_assert_not_reached();
	 break;
      case Ua4:
	 if (direction == UDP_IN)
	    {
	       ((rome->stat_udp).got_0xa4)++;
	       ((rome->stat_udp).got_0xa4_bytes) += size;
	    }
	 else if (direction == UDP_OUT)
	    {
	       ((rome->stat_udp).sent_0xa4)++;
	       ((rome->stat_udp).sent_0xa4_bytes) += size;
	    }
	 else
	    g_assert_not_reached();
	 break;

	 //unknown packet

      case U00:
	 if (direction == UDP_IN)
	    {
	       ((rome->stat_udp).got_unknown)++;
	       ((rome->stat_udp).got_unknown_bytes) += size;
	    }
	 else if (direction == UDP_OUT)
	    {
	       g_assert_not_reached();
	    }
	 else
	    g_assert_not_reached();
	 break;

      default:
	 g_assert_not_reached();
      }

   return 1;
}





gint
recheck_log_files()
{
   FILE* test;
   
   if (rome->settings.log_text_searches_tcp || rome->settings.log_text_searches_udp)
      {
	 if (rome->log_files.searches == NULL)
	    {
	       test = fopen("log_searches.dat", "a");
	       if (!test) return 0;
	       rome->log_files.searches = test;
	    }
      }
   else if (rome->log_files.searches)
      {
	 fclose(rome->log_files.searches);
	 rome->log_files.searches = NULL;
      }
	 
   
   if (rome->settings.log_user_events)
      {
	 if (rome->log_files.user_events == NULL)
	    {
	       test = fopen("log_uevents.dat", "a");
	       if (!test) return 0;
	       rome->log_files.user_events = test;
	    }
      }
   else if (rome->log_files.user_events)
      {
	 fclose(rome->log_files.user_events);
	 rome->log_files.user_events = NULL;
      }


   if (rome->settings.log_files)
      {
	 if (rome->log_files.files == NULL)
	    {
	       test = fopen("log_files.dat", "a");
	       if (!test) return 0;
	       rome->log_files.files = test;
	    }
      }
   else if (rome->log_files.files)
      {
	 fclose(rome->log_files.files);
	 rome->log_files.files = NULL;
      }


   return 1;
}




guint
get_time()
{
   return (guint) time(NULL);
}





void
log_write_0xa0(GInetAddr *addr, guchar *server, gint direction)
{
   char server_addr_str[16];

   if (ndl(5))
      {
	 if (direction == UDP_IN)
	    printf("[srvann<-] from %-16s:%-5d\n", gnet_inetaddr_get_canonical_name(addr),
		   gnet_inetaddr_get_port(addr));
	 else
	    printf("[srvann->] to   %-16s:%-5d\n", gnet_inetaddr_get_canonical_name(addr),
		gnet_inetaddr_get_port(addr)+4);
      }


   if ((rome->settings.log_everything || rome->settings.log_sent_announces)
       && (direction == UDP_IN))
      {
	 inet_ntoc(*(guint*)server, server_addr_str);
	 fprintf(rome->log_files.trace, 
		 "%12d 0xa0 IN from %-16s:%-5d content %-16s:%-5d\n",
		 get_time(), gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr),
		 server_addr_str, *((gushort*)(server+4)) ); 
      }
   else if ((rome->settings.log_everything || rome->settings.log_sent_announces)
       && (direction == UDP_OUT))
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0xa0 OUT  to %s:%d\n",
		 get_time(), gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr)+4); 
      }
}





void
log_write_0xa4(GInetAddr *addr, gint direction)
{
   if (ndl(5))
      {
	 if (direction == UDP_OUT)
	    printf("[srvlst?>] to   ");
	 else
	    printf("[srvlst?<] from ");
	 
	 printf("%s16:%-5d\n", gnet_inetaddr_get_canonical_name(addr),
		gnet_inetaddr_get_port(addr)+4);
      }

   
   if ((rome->settings.log_everything || rome->settings.log_recv_srvlist_requests_udp)
       && (direction == UDP_IN))
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0xa4 IN from %-16s:%-5d\n",
		 get_time(), gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr)+4); 
      }
   else if ((rome->settings.log_everything || rome->settings.log_sent_srvlist_requests_udp)
	    && (direction == UDP_OUT))
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0xa4 OUT  to %-16s:%-5d\n",
		 get_time(), gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr)+4); 
      }
}
	       




// udp query sources
void 
log_write_0x9a(GInetAddr *addr, guchar *hash)
{
   if (ndl(5))
      {
	 printf("[hash? <-] from %-16s:%-5d hash %8x%8x%8x%8x\n",
		gnet_inetaddr_get_canonical_name(addr),
		gnet_inetaddr_get_port(addr), 
		*(guint*)(hash), *(guint*)(hash+4),
		*(guint*)(hash+8), *(guint*)(hash+12)); 
      }
   if (rome->settings.log_query_sources_udp || rome->settings.log_everything)
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x9a IN from %s15:%-5d hash %8x%8x%8x%8x\n",
		 get_time(),
		 gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr), 
		 *(guint*)(hash), *(guint*)(hash+4),
		 *(guint*)(hash+8), *(guint*)(hash+12)); 
      }
}






void
log_write_0x97(GInetAddr *addr, guint challenge, gint direction)
{
   if (ndl(5))
      {
	 if (direction == UDP_OUT)
	    printf("[pong  ->] to   ");
	 else
	    printf("[pong  <-] from ");

	 printf("%-16s:%-5d challenge %8x\n", 
		gnet_inetaddr_get_canonical_name(addr),
		gnet_inetaddr_get_port(addr), 
		challenge);
      }


   if ((rome->settings.log_everything || rome->settings.log_sent_pongs)
       && (direction == UDP_OUT))
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x97 OUT  to %-16s:%-5d challenge %8x\n",
		 get_time(),
		 gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr), challenge); 
      }
   else if ((rome->settings.log_everything || rome->settings.log_recv_pongs)
	    && ( direction == UDP_IN))
      {
	 
	 fprintf(rome->log_files.trace, 
		 "%12d 0x97 IN from %-16s:%-5d challenge %8x\n",
		 get_time(),
		 gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr), challenge); 
      }
}







void
log_write_0x96(GInetAddr *addr, guint challenge, gint direction)
{
   if (ndl(5))
      {
	 if (direction == UDP_OUT)
	    printf("[ping  ->] to   ");
	 else
	    printf("[ping  <-] from ");

	 printf("%-16s:%-5d challenge %8x\n", 
	     gnet_inetaddr_get_canonical_name(addr),
	     gnet_inetaddr_get_port(addr), challenge);
      }


   if ((rome->settings.log_everything || rome->settings.log_sent_pings)
       && ( direction == UDP_OUT))
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x96 OUT  to %s16:%-5d challenge %8x\n",
		 get_time(),
		 gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr), challenge); 
      }
   else if ((rome->settings.log_everything || rome->settings.log_recv_pings)
	    && ( direction == UDP_IN))
      {
	 
	 fprintf(rome->log_files.trace, 
		 "%12d 0x96 IN from %s:%d challenge %8x\n",
		 get_time(),
		 gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr), challenge); 
      }
}






// send download sources
void 
log_write_0x9b(GInetAddr *addr, gint num_results)
{
   if (ndl(5))
      printf("[sources>] to   %-16s:%-5d num_results %d\n", 
	     gnet_inetaddr_get_canonical_name(addr),
	     gnet_inetaddr_get_port(addr),
	     num_results);

   if (rome->settings.log_everything || rome->settings.log_query_sources_answers_udp)
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x9b OUT  to %-16s:%-5d num_results %d\n",
		 get_time(),
		 gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr),
		 num_results); 
      }
}




// push requests
void 
log_write_0x9c(GInetAddr *addr, guchar *addr_to_push)
{
   char addr_to_push_str[16];

   if (ndl(5))
      {
	 inet_ntoc(*(guint*)addr_to_push, addr_to_push_str);
	 printf("[pushreq<] to   %-16s:%-5d from %-16s:%-5d\n", 
		gnet_inetaddr_get_canonical_name(addr),
		gnet_inetaddr_get_port(addr),
		addr_to_push_str, *(gushort*)(addr_to_push+4) );
      }
   if (rome->settings.log_everything || rome->settings.log_pushrequests_udp)
      {
	 inet_ntoc(*(guint*)addr_to_push, addr_to_push_str);
	 fprintf(rome->log_files.trace, 
		 "%12d 0x9b IN from %-16s:%-5d push %-16s:%-5d\n",
		 get_time(),
		 gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr),
		 addr_to_push_str, *(gushort*)(addr_to_push+4)); 
      }
}




// serverlists
void 
log_write_0xa1(GInetAddr *addr, guint num_servers, gint direction)
{
   if (ndl(5))
      {
	 if (direction == UDP_OUT)
	    printf("[srvlist>] to   ");
	 else
	    printf("[srvlist<] from ");
	 printf("%-16s:%-5d num_servers %d\n", 
		gnet_inetaddr_get_canonical_name(addr),
		gnet_inetaddr_get_port(addr),
		num_servers);
      }
   
   if ((rome->settings.log_everything || rome->settings.log_sent_serverlists_udp)
       && (direction == UDP_OUT))
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0xa1 OUT  to %-16s:%-5d num_servers %d\n",
		 get_time(),
		 gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr),
		 num_servers); 
      }
   else if ((rome->settings.log_everything || rome->settings.log_recv_serverlists_udp)
	    && (direction == UDP_IN))
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0xa1 IN from %-16s:%-5d num_servers %d\n",
		 get_time(),
		 gnet_inetaddr_get_canonical_name(addr),
		 gnet_inetaddr_get_port(addr), 
		 num_servers); 
      }
}




// send serverlist
void
log_write_0x32(struct UserInfo *user)
{
   if (ndl(3))
     printf("[srvlist>] to   %16s\n", user->inet_addr);
     
   if (rome->settings.log_everything || rome->settings.log_sent_serverlists_tcp)
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x32 OUT  to %16s\n",
		 get_time(), user->inet_addr);
      }
}



// text search results 
void
log_write_0x33(struct UserInfo *user, gint num_results)
{
   if (ndl(3))
      printf("[filelst>] to   %16s num_results %d\n", 
	     user->inet_addr, num_results);

   if (rome->settings.log_everything || rome->settings.log_text_search_answers_tcp)
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x33 OUT  to %16s num_results %d\n", 
		 get_time(), user->inet_addr, num_results);
      }
}





// server status
void
log_write_0x34(struct UserInfo *user)
{
   if (ndl(3))
      printf("[status->] to   %16s \n", user->inet_addr);
   if (rome->settings.log_everything || rome->settings.log_sent_serverstatus_tcp)
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x34 OUT  to %16s\n",
		 get_time(), user->inet_addr);
      }
}



// push command
void
log_write_0x35(struct UserInfo *user, guchar *push_addr)
{
   char push_addr_str[16];

   if (ndl(3))
      {
	 inet_ntoc(*(guint*)push_addr, push_addr_str);
	 printf("[pushreq>] to   %16s from %-16s:%-5d\n",
		user->inet_addr, 
		push_addr_str, *(gushort*)(push_addr+4));
      }

   if (rome->settings.log_everything || rome->settings.log_pushrequests_tcp)
      {
	 inet_ntoc(*(guchar*)push_addr, push_addr_str);
	 fprintf(rome->log_files.trace, 
		 "%12d 0x35 OUT  to %16s from %s:%-5d\n", 
		 get_time(), user->inet_addr, 
		 push_addr_str, *(gushort*)(push_addr+4));
      }
}



// write string
void
log_write_0x38(struct UserInfo *user, gint str_size)
{
   if (ndl(4))
      {
	 printf("[string->] to   %16s size %d\n",
		user->inet_addr, str_size);
      }

   // has to be enabled seperately!!
   if (rome->settings.log_strings)
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x38 OUT  to %16s size %d\n", 
		 get_time(), user->inet_addr, str_size);
      }
}



// set id
void
log_write_0x40(struct UserInfo *user)
{
   if (ndl(3))
      {
	 printf("[ID    ->] to   %16s id %d\n",
		user->inet_addr, user->id);
      }

   if (rome->settings.log_everything || rome->settings.log_ids)
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x40 OUT  to %s id %d\n", 
		 get_time(), user->inet_addr, user->id);
      }

}


// send server description
void
log_write_0x41(struct UserInfo *user)
{
   if (ndl(3))
      {
	 printf("[srvdesc>] to   %16s\n",
		user->inet_addr);
      }

   if (rome->settings.log_everything || rome->settings.log_sent_serverdescs_tcp)
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x41 OUT  to %16s\n", 
		 get_time(), user->inet_addr);
      }

}



// send download sources
void
log_write_0x42(struct UserInfo *user, gint num_results)
{
   if (ndl(3))
      {
	 printf("[sources>] to   %-16s:%5d num_results %d\n",
		user->inet_addr, user->port, num_results);
      }

   if (rome->settings.log_everything || rome->settings.log_query_sources_answers_tcp)
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x42 OUT  to %16s results %d\n", 
		 get_time(), user->inet_addr, num_results);
      }

}




void
log_write_0x01(struct UserInfo *user)
{

   if ( nvl(1) || ndl(1) )
      {
	 g_print("[newuser+] + %s:%d ver %3d id %15u name '%s'\n", 
		 user->inet_addr, user->port, user->version, 
		 user->id, user->name);   
      }


   if (rome->settings.log_user_events || rome->settings.log_everything)
      {
	 fprintf(rome->log_files.user_events,
		 "%12d 0x01 IN from %-16s:%-5d ver %3d name %s\n",
		 get_time(),
		 user->inet_addr, user->port, user->version, user->name);

	 if (rome->settings.log_everything)
	    fprintf(rome->log_files.trace,
		    "%12d 0x01 IN from %-16s:%-5d ver %3d name %s\n",
		    get_time(),
		    user->inet_addr, user->port, user->version, user->name);
      }

}


// publish files
void 
log_write_0x15(struct UserInfo *user, int num_files)
{
   if (ndl(3))
      printf("[files <-] from %-16s:%-5d offers %d files\n", 
	     user->inet_addr, user->port, num_files);

   if (rome->settings.log_everything)
      {
	 fprintf(rome->log_files.trace, 
		 "%12d 0x15 IN from %-16s:%-5d offesr %d files\n",
		 get_time(),
		 user->inet_addr, user->port, num_files);
      }

}



// query sources 
void
log_write_0x19(struct UserInfo *user, guchar *hash)
{
   if (ndl(3))
      printf("[hash? <-] from %-16s:%-5d hash: %8x%8x%8x%8x\n",
	     user->inet_addr, user->port,
	     *(unsigned int*)(hash),
	     *(unsigned int*)(hash+4),
	     *(unsigned int*)(hash+8),
	     *(unsigned int*)(hash+12));

   if (rome->settings.log_everything || rome->settings.log_query_sources_tcp)
      {
	 fprintf(rome->log_files.searches, 
		 "%12d 0x19 IN from %-16s:%-5d hash: %8x%8x%8x%8x\n",
		 get_time(),
		 user->inet_addr, user->port,
		 *(unsigned int*) (hash),
		 *(unsigned int*) (hash+4),
		 *(unsigned int*) (hash+8),
		 *(unsigned int*) (hash+12));
	 
	 if (rome->settings.log_everything)
	    fprintf(rome->log_files.trace, 
		    "%12d 0x19 IN from %-16s:%-5d hash: %8x%8x%8x%8x\n",
		    get_time(),
		    user->inet_addr, user->port,
		    *(unsigned int*) (hash),
		    *(unsigned int*) (hash+4),
		    *(unsigned int*) (hash+8),
		    *(unsigned int*) (hash+12));
      }
}
