/* ************************************************************************** *
   This file is part of ceDonkey.

   ceDonkey is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   ceDonkey is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with ceDonkey; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * ************************************************************************** */

#ifndef __logging
#define __logging 1

#include <gnet/gnet.h>

#include "structs.h"

// tcp: user, type, size
// udp: type, size, in/out


gint
logging_init();

gint
count_tcp_traffic(struct UserInfo *, gint, gint);

gint
count_udp_traffic(gint, gint, gint);

gint
write_regular_log();

gint
recheck_log_files();



void
log_write_0x01(struct UserInfo *);

void
log_write_0x32(struct UserInfo *);

void
log_write_0x33(struct UserInfo *, gint);

void
log_write_0x34(struct UserInfo *);

void
log_write_0x35(struct UserInfo *, guchar *);

void
log_write_0x38(struct UserInfo *, gint);

void
log_write_0x40(struct UserInfo *);

void
log_write_0x41(struct UserInfo *);

void
log_write_0x42(struct UserInfo *, gint);

void
log_write_0x96(GInetAddr*, guint, gint);

void
log_write_0x97(GInetAddr*, guint, gint);

void 
log_write_0x9a(GInetAddr *, guchar *);

void 
log_write_0x9b(GInetAddr*, gint);

void 
log_write_0x9c(GInetAddr *, guchar *);

void
log_write_0xa0(GInetAddr*, guchar*, gint);

void 
log_write_0xa1(GInetAddr*, guint, gint);

void
log_write_0xa4(GInetAddr*, gint);




#endif
